// This program is copyright VUW.
// You are granted permission to use it to construct your answer to a COMP102 assignment.
// You may not distribute it in any other way without permission.

/* Code for COMP102 - 2019T2, Mid-Term Test 2
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;
import java.util.ArrayList;
import java.util.Scanner;
import java.io.File;

/**
 * Question 5. ArrayLists                          [10 marks]
 * 
 * Suppose the q5data.txt file contains a sequence of numbers.
 * Complete the findSingletons method below
 * that will print out all the numbers that do not match the
 * numbers to either side of them.
 * 
 *  For example, if the file contains
 *      “2 2 3 5 3 3 3 9 1 2 3 5 5 5 5 5 5 5 4 4 4 2 2 1”,
 *  your method should print:
 *       3 5 9 1 2 3 1 
 *      
 *  The first line (done for you) calls the readAllNumbers
 *  method to load the numbers into an ArrayList. Numbers at
 *  the start and end are singletons if they do not match the
 *  number next to them.
 */
public class Program5
{
    public void findSingletons(){
        ArrayList <Integer> nums = readAllNumbers("q5data.txt");
        /*# YOUR CODE HERE */
        
    }
 
    /**
     * Reads the given file and stores all the numbers in a list.
     */
    public ArrayList <Integer> readAllNumbers(String filename){
        ArrayList <Integer> nums = new ArrayList<Integer>();
        try{
            Scanner scan = new Scanner(new File(filename));
            while (scan.hasNextInt()){
                nums.add(scan.nextInt());
            }
            scan.close();
        }
        catch(Exception e) {UI. println ("File error");}
        return nums;
    }
    
    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    public void setupGUI() {
        UI.initialise();
        UI.addButton("Run", this::findSingletons);
        UI.setWindowSize(500,500);
        UI.setDivider(1.0);
    }
    
    public static void main(String[] args) {
        new Program5().setupGUI();
    }
}
